/* Tabela ITMAPARECUP: Itens de apurao que compem os valores no detalhamento do Mapa de Apurao */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ITMAPARECUP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela de itens de apurao do detalhamento do Mapa de Apurao,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_FIS_ITMAPARECUP
AFTER DELETE OR INSERT OR UPDATE
ON ITMAPARECUP FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(50);
   V_DSREMOTEHOST VARCHAR2(50);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(50);
   V_DSREMOTEOPER VARCHAR2(12);
   V_NMOPERADOR   VARCHAR2(100);
   V_TIPO         VARCHAR2(1);
   V_DESC         VARCHAR2(1000);
   V_CDFILLOGOPER VARCHAR2(4);
   V_ITPESQ       VARCHAR2(40);
   V_DTOPER       DATE;
   V_STATUS       VARCHAR2(10);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.DSITEMMAPR IS NOT NULL THEN
         V_DESC := V_DESC || 'DescricaoItem=' || :OLD.DSITEMMAPR;
      END IF;
      IF :OLD.VRITEMMAPR IS NOT NULL THEN
         V_DESC := V_DESC || ' VrItem=' || :OLD.VRITEMMAPR;
      END IF;
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' FilialNF=' || :OLD.CDFILIAL;
      END IF;
      IF :OLD.NRLANCTONF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrLancamentoNF=' || :OLD.NRLANCTONF;
      END IF;
      IF :OLD.CDAJUSTEITMAPA IS NOT NULL THEN
         V_DESC := V_DESC || ' CodAjuste=' || :OLD.CDAJUSTEITMAPA;
      END IF;
      IF :OLD.CDITPROCEDENCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CodProcedencia=' || :OLD.CDITPROCEDENCIA;
      END IF;
      IF :OLD.CDAJUSTEITSEF IS NOT NULL THEN
         V_DESC := V_DESC || ' CodAjusteSEF=' || :OLD.CDAJUSTEITSEF;
      END IF;
      IF :OLD.IDCREDPRESUMIDO IS NOT NULL THEN
         V_DESC := V_DESC || ' IdCredPresumido=' || :OLD.IDCREDPRESUMIDO;
      END IF;      
      IF :OLD.IDDIFALMANUAL IS NOT NULL THEN
         V_DESC := V_DESC || ' IdDifal=' || :OLD.IDDIFALMANUAL;
      END IF;
      IF :OLD.IDCARGATRIBUTARIA IS NOT NULL THEN
         V_DESC := V_DESC || ' IdCargaTrib=' || :OLD.IDCARGATRIBUTARIA;
      END IF;
      IF :OLD.CDCFOPPADRAO IS NOT NULL THEN
         V_DESC := V_DESC || ' Cfop=' || :OLD.CDCFOPPADRAO;
      END IF;
      IF :OLD.IDCOMPOEC197 IS NOT NULL THEN
         V_DESC := V_DESC || ' CompoeC197=' || :OLD.IDCOMPOEC197;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.NRSEQUMAPAPU||:OLD.IDTIPOITMAPR||:OLD.NRSEQITMAPR;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.DSITEMMAPR, '!')        <> NVL(:OLD.DSITEMMAPR, '!')        OR
            NVL(:NEW.VRITEMMAPR, 0)          <> NVL(:OLD.VRITEMMAPR, 0)          OR
            NVL(:NEW.CDFILIAL, '!')          <> NVL(:OLD.CDFILIAL, '!')          OR
            NVL(:NEW.NRLANCTONF, '!')        <> NVL(:OLD.NRLANCTONF, '!')        OR
            NVL(:NEW.CDAJUSTEITMAPA, '!')    <> NVL(:OLD.CDAJUSTEITMAPA, '!')    OR
            NVL(:NEW.CDITPROCEDENCIA, '!')   <> NVL(:OLD.CDITPROCEDENCIA, '!')   OR
            NVL(:NEW.CDAJUSTEITSEF, '!')     <> NVL(:OLD.CDAJUSTEITSEF, '!')     OR
            NVL(:NEW.IDCREDPRESUMIDO, '!')   <> NVL(:OLD.IDCREDPRESUMIDO,  '!')  OR
            NVL(:NEW.IDDIFALMANUAL, '!')     <> NVL(:OLD.IDDIFALMANUAL, '!')     OR
            NVL(:NEW.IDCARGATRIBUTARIA, '!') <> NVL(:OLD.IDCARGATRIBUTARIA, '!') OR
            NVL(:NEW.CDCFOPPADRAO, '!')      <> NVL(:OLD.CDCFOPPADRAO, '!')      OR
            NVL(:NEW.IDCOMPOEC197, '!')      <> NVL(:OLD.IDCOMPOEC197, '!')      THEN            
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.NRSEQUMAPAPU||:OLD.IDTIPOITMAPR||:OLD.NRSEQITMAPR;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.NRSEQUMAPAPU||:NEW.IDTIPOITMAPR||:NEW.NRSEQITMAPR;
      END IF;

      IF NVL(:NEW.DSITEMMAPR, '!') <> NVL(:OLD.DSITEMMAPR, '!') THEN
         V_DESC := V_DESC || 'DescricaoItem=' || :NEW.DSITEMMAPR;
      END IF;
      IF NVL(:NEW.VRITEMMAPR, 0) <> NVL(:OLD.VRITEMMAPR, 0) THEN
         V_DESC := V_DESC || ' VrItem=' || :NEW.VRITEMMAPR;
      END IF;
      IF NVL(:NEW.CDFILIAL, '!') <> NVL(:OLD.CDFILIAL, '!') THEN
         V_DESC := V_DESC || ' FilialNF=' || :NEW.CDFILIAL;
      END IF;
      IF NVL(:NEW.NRLANCTONF, '!') <> NVL(:OLD.NRLANCTONF, '!') THEN
         V_DESC := V_DESC || ' NrLancamentoNF=' || :NEW.NRLANCTONF;
      END IF;
      IF NVL(:NEW.CDAJUSTEITMAPA, '!') <> NVL(:OLD.CDAJUSTEITMAPA, '!') THEN
         V_DESC := V_DESC || ' CodAjuste=' || :NEW.CDAJUSTEITMAPA;
      END IF;
      IF NVL(:NEW.CDITPROCEDENCIA, '!') <> NVL(:OLD.CDITPROCEDENCIA, '!') THEN
         V_DESC := V_DESC || ' CodProcedencia=' || :NEW.CDITPROCEDENCIA;
      END IF;
      IF NVL(:NEW.CDAJUSTEITSEF, '!') <> NVL(:OLD.CDAJUSTEITSEF, '!') THEN
         V_DESC := V_DESC || ' CodAjusteSEF=' || :NEW.CDAJUSTEITSEF;
      END IF;
      IF NVL(:NEW.IDCREDPRESUMIDO, '!') <> NVL(:OLD.IDCREDPRESUMIDO, '!') THEN
         V_DESC := V_DESC || ' IdCredPresumido=' || :NEW.IDCREDPRESUMIDO;
      END IF;
      IF NVL(:NEW.IDDIFALMANUAL, '!') <> NVL(:OLD.IDDIFALMANUAL, '!') THEN
         V_DESC := V_DESC || ' IdDifal=' || :NEW.IDDIFALMANUAL;
      END IF;
      IF NVL(:NEW.IDCARGATRIBUTARIA, '!') <> NVL(:OLD.IDCARGATRIBUTARIA, '!') THEN
         V_DESC := V_DESC || ' IdCargaTrib=' || :NEW.IDCARGATRIBUTARIA;
      END IF;
	  IF NVL(:NEW.CDCFOPPADRAO, '!') <> NVL(:OLD.CDCFOPPADRAO, '!') THEN
         V_DESC := V_DESC || ' Cfop=' || :NEW.CDCFOPPADRAO;
      END IF;
      IF NVL(:NEW.IDCOMPOEC197, '!') <> NVL(:OLD.IDCOMPOEC197, '!') THEN
         V_DESC := V_DESC || ' CompoeC197=' || :NEW.IDCOMPOEC197;
      END IF;      
   END IF;

   IF  V_TIPO <> '0' THEN
       NMUSUARIO(V_NMOPERADOR);
       WEBTUNNING(V_DSREMOTEADDR,
                  V_DSREMOTEHOST,
                  V_DSSERVERRDM,
                  V_DSSERVMETHOD,
                  V_DSREMOTEOPER);

       IF NOT V_DESC IS NULL THEN
         IF NOT V_NMOPERADOR IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,   IDTIPOOPER,  CDPESQITEM,  DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER,CDORESPOPER)
            VALUES
               ('ITMAPARECUP',    V_DTOPER,      V_NMOPERADOR,   V_TIPO,         V_ITPESQ,       SUBSTR(V_DESC,1,400),
                V_CDFILLOGOPER, V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
       END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_ITMAPARECUP','5.87.000'); END;
/
